PyMOLMeshReader
Date: 2019-10-22

org.jmol.jvxl.readers

## Class PyMOLMeshReader

- java.lang.Object
- - org.jmol.jvxl.readers.SurfaceReader
  - - org.jmol.jvxl.readers.SurfaceFileReader
    - - org.jmol.jvxl.readers.VolumeFileReader
      - - org.jmol.jvxl.readers.MapFileReader
        - - org.jmol.jvxl.readers.PyMOLMeshReader

- All Implemented Interfaces:
    VertexDataServer

      class PyMOLMeshReader
      extends MapFileReader

  PyMOL surface/mesh reader. PyMOL "mesh": Describes a cutoff and "carving" distance around a set of points PyMOL "map": Volume data used by mesh (HupA_2) or direct visualization (HupA_LC)
  Author:
    Bob Hanson

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `(package private) static int` | `cMapSourceBRIX`
    `(package private) static int` | `cMapSourceCCP4`
    `(package private) static int` | `cMapSourceChempyBrick`
    `(package private) static int` | `cMapSourceCrystallographic`
    `(package private) static int` | `cMapSourceDesc`
    `(package private) static int` | `cMapSourceFLD`
    `(package private) static int` | `cMapSourceGeneralPurpose`
    `(package private) static int` | `cMapSourceGRD`
    `(package private) static int` | `cMapSourceObsolete`
    `(package private) static int` | `cMapSourceVMDPlugin`
    `private javajs.util.Lst<java.lang.Object>` | `data`
    `private boolean` | `isMesh`
    `(package private) static int` | `OBJECT_MAPDATA`
    `(package private) static int` | `OBJECT_MAPMESH`
    `private int` | `pt`
    `private int` | `pymolType`
    `private java.lang.String` | `surfaceName`
    `private javajs.util.Lst<java.lang.Object>` | `voxelList`

    - ### Fields inherited from class org.jmol.jvxl.readers.MapFileReader

      `a, alpha, b, beta, c, dmax, dmean, dmin, drange, gamma, mapc, mapr, maps, mode, n0, n1, n2, na, nb, nc, origin, p3, vectors, xIndex, xyzStart, yIndex, zIndex`

    - ### Fields inherited from class org.jmol.jvxl.readers.VolumeFileReader

      `ac, boundingBox, canDownsample, downsampleFactor, downsampleRemainders, endOfData, isAngstroms, nData, negativeAtomCount, nSkipX, nSkipY, nSkipZ, nSurfaces, readerClosed`

    - ### Fields inherited from class org.jmol.jvxl.readers.SurfaceFileReader

      `binarydoc, br, line, next, out`

    - ### Fields inherited from class org.jmol.jvxl.readers.SurfaceReader

      `allowSigma, ANGSTROMS_PER_BOHR, anisotropy, center, cJvxlEdgeNaN, colorFractionBase, colorFractionRange, contourVertexCount, dataMax, dataMean, dataMin, defaultCutoff, defaultMappedDataMax, defaultMappedDataMin, eccentricityMatrix, eccentricityMatrixInverse, eccentricityRatio, eccentricityScale, edgeFractionBase, edgeFractionRange, fractionData, hasColorData, haveSurfaceAtoms, isAnisotropic, isEccentric, isJvxl, isPeriodic, isProgressive, isQuiet, isXLowToHigh, jvxlColorDataRead, jvxlCutoff, jvxlData, jvxlDataIs2dContour, jvxlDataIsColorDensity, jvxlDataIsColorMapped, jvxlDataIsPrecisionColor, jvxlEdgeDataRead, jvxlFileHeaderBuffer, jvxlNSurfaceInts, jvxlVoxelBitSet, marchingCubes, marchingSquares, meshData, meshDataServer, minMax, nBytes, nDataPoints, nPointsX, nPointsY, nPointsZ, params, ptTemp, qpc, sg, vertexDataOnly, volumeData, volumetricOrigin, volumetricVectors, voxelCounts, voxelData, xyzMax, xyzMin, yzCount, yzPlanes`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PyMOLMeshReader()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `private float` | `calculateCutoff()`
    `private float` | `getFloat(javajs.util.Lst<java.lang.Object> list, int i)`
    `private static javajs.util.Lst<java.lang.Object>` | `getList(javajs.util.Lst<java.lang.Object> list, int i)`
    `(package private) void` | `init2(SurfaceGenerator sg, java.io.BufferedReader brNull)`
    `protected float` | `nextVoxel()`
    `protected void` | `readParameters()`
    `protected void` | `setCutoffAutomatic()`
    `protected void` | `skipData(int nPoints)`

    - ### Methods inherited from class org.jmol.jvxl.readers.MapFileReader

      `checkInsideOut, getVectorsAndOrigin, init2MFR`

    - ### Methods inherited from class org.jmol.jvxl.readers.VolumeFileReader

      `checkAtomLine, closeReader, getNextVoxelValue, getPlane, getPlaneNCI, getSPFv, getSurfacePointAndFraction, getValue, getVoxelBitSet, gotoData, init2VFR, initializeSurfaceData, readSurfaceData, readSurfaceDataVFR, readVolumeData, readVolumeDataVFR, readVolumeParameters, readVoxelVector, recordData, skipComments, skipDataVFR, swapXZ`

    - ### Methods inherited from class org.jmol.jvxl.readers.SurfaceFileReader

      `closeReaderSFR, discardTempData, getQuotedStringNext, getTokens, init, init2SFR, newBinaryDocument, parseFloat, parseFloatArray, parseFloatArrayStr, parseFloatRange, parseFloatStr, parseInt, parseIntNext, parseIntStr, rd, setOutputChannel, setStream, skipTo`

    - ### Methods inherited from class org.jmol.jvxl.readers.SurfaceReader

      `addTriangleCheck, addVC, addVertexCopy, applyColorScale, colorIsosurface, createIsosurface, discardTempDataSR, excludeMaximumSet, excludeMinimumSet, finalizeMapping, getColorPhaseIndex, getMinMaxMappedValues, getPlaneSR, getSPF, getSurfaceAtomIndex, getSurfacePointIndexAndFraction, getValue2, getValueAtPoint, gotoAndReadVoxelData, initializeMapping, initializeVolumetricData, initPlanes, initSR, jvxlUpdateInfo, newVoxelDataCube, postProcessVertices, readAndSetVolumeParameters, readColorData, resetIsosurface, selectPocket, setBBox, setVectorAnisotropy, setVertexAnisotropy, setVolumeDataV, setVolumetricAnisotropy, setVolumetricOriginAnisotropy, slabIsosurface, updateSurfaceData, updateTriangles`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### data

          private javajs.util.Lst<java.lang.Object> data

    - #### voxelList

          private javajs.util.Lst<java.lang.Object> voxelList

    - #### surfaceName

          private java.lang.String surfaceName

    - #### pymolType

          private int pymolType

    - #### isMesh

          private boolean isMesh

    - #### cMapSourceCrystallographic

          static final int cMapSourceCrystallographic

      See Also:
        Constant Field Values

    - #### cMapSourceCCP4

          static final int cMapSourceCCP4

      See Also:
        Constant Field Values

    - #### cMapSourceGeneralPurpose

          static final int cMapSourceGeneralPurpose

      See Also:
        Constant Field Values

    - #### cMapSourceDesc

          static final int cMapSourceDesc

      See Also:
        Constant Field Values

    - #### cMapSourceFLD

          static final int cMapSourceFLD

      See Also:
        Constant Field Values

    - #### cMapSourceBRIX

          static final int cMapSourceBRIX

      See Also:
        Constant Field Values

    - #### cMapSourceGRD

          static final int cMapSourceGRD

      See Also:
        Constant Field Values

    - #### cMapSourceChempyBrick

          static final int cMapSourceChempyBrick

      See Also:
        Constant Field Values

    - #### cMapSourceVMDPlugin

          static final int cMapSourceVMDPlugin

      See Also:
        Constant Field Values

    - #### cMapSourceObsolete

          static final int cMapSourceObsolete

      See Also:
        Constant Field Values

    - #### OBJECT_MAPDATA

          static final int OBJECT_MAPDATA

      See Also:
        Constant Field Values

    - #### OBJECT_MAPMESH

          static final int OBJECT_MAPMESH

      See Also:
        Constant Field Values

    - #### pt

          private int pt

  - ### Constructor Detail

    - #### PyMOLMeshReader

          PyMOLMeshReader()

  - ### Method Detail

    - #### init2

          void init2(SurfaceGenerator sg,
                     java.io.BufferedReader brNull)

      Overrides:
        `init2` in class `MapFileReader`

    - #### getList

          private static javajs.util.Lst<java.lang.Object> getList(javajs.util.Lst<java.lang.Object> list,
                                                                   int i)

    - #### readParameters

          protected void readParameters()
                                 throws java.lang.Exception

      Specified by:
        `readParameters` in class `VolumeFileReader`
      Throws:
        `java.lang.Exception`

    - #### nextVoxel

          protected float nextVoxel()
                             throws java.lang.Exception

      Overrides:
        `nextVoxel` in class `VolumeFileReader`
      Throws:
        `java.lang.Exception`

    - #### getFloat

          private float getFloat(javajs.util.Lst<java.lang.Object> list,
                                 int i)

    - #### skipData

          protected void skipData(int nPoints)
                           throws java.lang.Exception

      Overrides:
        `skipData` in class `VolumeFileReader`
      Throws:
        `java.lang.Exception`

    - #### setCutoffAutomatic

          protected void setCutoffAutomatic()

      Overrides:
        `setCutoffAutomatic` in class `MapFileReader`

    - #### calculateCutoff

          private float calculateCutoff()